"""Common

This module is ment to maintain all common functions between servers

"""
from flask import make_response, jsonify
CLI_PATH = ''
HOST_IP = ''
PORT = ''
UPLOAD_FOLDER = '/tmp'
ALLOWED_EXTENSIONS = {'txt', 'kpabe', 'msk.kpabe', 'key', 'json'}

def default_success_code():
    message = {
        'message': 'OK',
        'status_code': 200
    }
    return make_response(jsonify(message), 200)

def success_code_with_extra_data(data):
    """
    data (:obj:`dict` of :obj:`str` keys and :obj:`obj` values)
    """
    message = {
        'message': 'OK',
        'status_code': 200
    }
    for k,v in data.items():
        if k not in message:
            message[k] = v
    return make_response(jsonify(message), 200)

def default_error_code(code, stdout, stderr):
    message = {
        'message': 'FAIL',
        'stdout': stdout,
        'stderr': stderr,
        'status_code': code
    }
    return make_response(jsonify(message), code)

def allowed_file(filename):
    return '.' in filename and \
           filename.rsplit('.', 1)[1].lower() in ALLOWED_EXTENSIONS

def subprocess_and_call(on_exit, on_fail, list_args):
    thread = threading.Thread(target=subprocess_and_wait, args=(on_exit, on_fail, list_args))
    thread.start()
    return thread

def subprocess_and_wait(on_exit, on_fail, list_args):
    proc = subprocess.Popen(' '.join(list_args), shell=True)
    proc.wait()
    (stdout, stderr) = proc.communicate()
    if proc.returncode != 0:
        return on_fail(500, stdout, stderr)
    else:
        return on_exit()

def common_parser(parser):
    parser.add_argument('--host', dest='host_ip', type=str, default='192.168.1.5', help='Flask host IP')
    parser.add_argument('--port', dest='port', type=int, default=8080, help='Flask host port')
    parser.add_argument('--config', dest='config', type=str, default="config.conf", help='Config File')
    return parser
