#!/bin/bash

OABE_PATH=/home/vagrant/openabe/cli;
oabe_dec=$OABE_PATH/oabe_dec;
oabe_enc=$OABE_PATH/oabe_enc;
oabe_keygen=$OABE_PATH/oabe_keygen;
oabe_setup=$OABE_PATH/oabe_setup;


$oabe_setup -s KP -p KPorg
$oabe_keygen -s KP -p KPorg -i "(From:Alice and (Date = March 1-14, 2017 or Date = February 22-28, 2017))" -o analystKP

touch test_openabe_native_lorem_results.csv

for INDEX in {1..1000}
do
    echo Iteration $INDEX;
    tr -dc a-z1-4 </dev/urandom | tr 1-2 ' \n' | awk 'length==0 || length>50' | tr 3-4 ' ' | sed 's/^ *//' | cat -s | sed 's/ / /g' |fmt | head -n 300000 > input.txt;
    split -b 16MB --additional-suffix=.txt input.txt input;
    echo -n $INDEX >> test_openabe_native_lorem_results.csv;
    /usr/bin/time -a -o test_openabe_native_lorem_results.csv -f ',ENC,%E,%U,%S,%M,%K,%D,%X' $oabe_enc -s KP -p KPorg -e "From:Alice|To:Bob|Date = March 7, 2017" -i inputaa.txt -o input.kpabe;
    echo -n $INDEX >> test_openabe_native_lorem_results.csv;
    /usr/bin/time -a -o test_openabe_native_lorem_results.csv -f ',DEC,%E,%U,%S,%M,%K,%D,%X' $oabe_dec -s KP -p KPorg -k analystKP.key -i input.kpabe -o ok.input.txt;
    # Verify Decryption is successful
    VARA=$(md5sum inputaa.txt | cut -d ' ' -f 1);
    VARB=$(md5sum ok.input.txt | cut -d ' ' -f 1);
    if [ $VARA != $VARB ]; then
        echo 'Failed to decrypt file';
        echo $VARA;
        echo $VARB;
        exit;
    fi
done

rm -f analystKP.key input.kpabe input.txt KPorg.mpk.kpabe KPorg.msk.kpabe ok.input.txt
